<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/reorder.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>reorder.c</h1><a href="reorder_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2006-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: reorder.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="reorder_8c.html#a6924d6317e2e503ad009880947d9f905">00030</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a6924d6317e2e503ad009880947d9f905">CheckPartition</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,<span class="keywordtype">int</span> parts)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> rank,size;
<a name="l00035"></a>00035   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00036"></a>00036   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (rank) {
<a name="l00039"></a>00039     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keywordtype">int</span> *nvertloc,*neleloc;
<a name="l00043"></a>00043   ierr = PetscMalloc((parts+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;nvertloc);CHKERRQ(ierr);
<a name="l00044"></a>00044   ierr = PetscMalloc((parts+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;neleloc);CHKERRQ(ierr);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;parts+1;i++) {
<a name="l00047"></a>00047     nvertloc[i]=0;
<a name="l00048"></a>00048     neleloc[i]=0;
<a name="l00049"></a>00049   }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">/* calculate offset in global arrays for each processor */</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00054"></a>00054     assert(gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]&lt;parts);
<a name="l00055"></a>00055     nvertloc[gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]+1]++;
<a name="l00056"></a>00056   }
<a name="l00057"></a>00057   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00058"></a>00058     assert(gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]&lt;parts);
<a name="l00059"></a>00059     neleloc[gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]+1]++;
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;parts+1;i++) {
<a name="l00062"></a>00062     nvertloc[i] += nvertloc[i-1];
<a name="l00063"></a>00063     neleloc[i]  += neleloc[i-1];
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;mesh partitioning:\n&quot;</span>);
<a name="l00067"></a>00067   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;parts;i++) {
<a name="l00068"></a>00068     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00069"></a>00069       <span class="stringliteral">&quot;proc. %2i: %7i elements %7i vertices\n&quot;</span>,
<a name="l00070"></a>00070       i,
<a name="l00071"></a>00071       neleloc[i+1]-neleloc[i],
<a name="l00072"></a>00072       nvertloc[i+1]-nvertloc[i]
<a name="l00073"></a>00073     );
<a name="l00074"></a>00074   }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   assert(nvertloc[0]==0);
<a name="l00077"></a>00077   assert(nvertloc[parts]==gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00078"></a>00078   assert(neleloc[0]==0);
<a name="l00079"></a>00079   assert(neleloc[parts]==gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   ierr = PetscFree(nvertloc);CHKERRQ(ierr);
<a name="l00082"></a>00082   ierr = PetscFree(neleloc);CHKERRQ(ierr);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/* display matrix structure (if X11 compiled in), calculate bandwidth */</span>
<a name="l00085"></a>00085   <span class="comment">/* TODO: only if X11 available for visualization: quite slow</span>
<a name="l00086"></a>00086 <span class="comment">     why? matviewstruct is fast, must be MatPermute then</span>
<a name="l00087"></a>00087 <span class="comment">  */</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   IS isvert;
<a name="l00090"></a>00090   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>,&amp;isvert);CHKERRQ(ierr);
<a name="l00091"></a>00091   ierr = ISSetPermutation(isvert);CHKERRQ(ierr);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   Mat Atest,Btest;
<a name="l00094"></a>00094   <a class="code" href="matcreateseqadj_8c.html#a75401ceb9e40834d9b15671f96a9c03a">matcreateseqadj</a>(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;Atest);
<a name="l00095"></a>00095   ierr = MatPermute(Atest,isvert,isvert,&amp;Btest);CHKERRQ(ierr);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   ierr = ISDestroy(isvert);CHKERRQ(ierr);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Adjacency matrix before partitioning:\n&quot;</span>);
<a name="l00100"></a>00100   ierr = <a class="code" href="matviewstruct_8c.html#a7c494f3571a8f64d0056e03cbf6c994a">matviewstruct</a>(PETSC_COMM_SELF,Atest);CHKERRQ(ierr);
<a name="l00101"></a>00101   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Adjacency matrix after partitioning:\n&quot;</span>);
<a name="l00102"></a>00102   ierr = <a class="code" href="matviewstruct_8c.html#a7c494f3571a8f64d0056e03cbf6c994a">matviewstruct</a>(PETSC_COMM_SELF,Btest);CHKERRQ(ierr);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   ierr = MatDestroy(Btest);CHKERRQ(ierr);
<a name="l00105"></a>00105   ierr = MatDestroy(Atest);CHKERRQ(ierr);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="comment">/* Permute data in gdata structure with new numbering */</span>
<a name="l00112"></a><a class="code" href="reorder_8c.html#a325dee9c88a63835d07e633aac72bc7e">00112</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a325dee9c88a63835d07e633aac72bc7e">PermuteData</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,IS isvert,IS isele)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keywordtype">int</span> rank,size;
<a name="l00117"></a>00117   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00118"></a>00118   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="keywordflow">if</span> (rank) {
<a name="l00121"></a>00121     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   AO t_ao;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">/* permute vertex data */</span>
<a name="l00127"></a>00127   ierr = AOCreateBasicIS(isvert,PETSC_NULL,&amp;t_ao);CHKERRQ(ierr);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   ierr = AOApplicationToPetscPermuteReal(t_ao,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>);CHKERRQ(ierr);
<a name="l00130"></a>00130   ierr = AOApplicationToPetsc(t_ao,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>);CHKERRQ(ierr);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00134"></a>00134     ierr = AOApplicationToPetscPermuteInt(t_ao,1,gdata-&gt;vertcoupl);CHKERRQ(ierr);
<a name="l00135"></a>00135     ierr = AOApplicationToPetsc(t_ao,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)gdata-&gt;vertcoupl);CHKERRQ(ierr);
<a name="l00136"></a>00136   }
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>
<a name="l00139"></a>00139 <span class="comment">/* more elegant than implementation with AOApplicationToPetscPermuteReal</span>
<a name="l00140"></a>00140 <span class="comment">   below but crashes with SEGV on single proc!</span>
<a name="l00141"></a>00141 <span class="comment">  ierr = VecPermute(gdata-&gt;M,isvert,PETSC_FALSE);CHKERRQ(ierr);</span>
<a name="l00142"></a>00142 <span class="comment">#ifdef ADDONS</span>
<a name="l00143"></a>00143 <span class="comment">  if (gdata-&gt;VH1!=PETSC_NULL) {</span>
<a name="l00144"></a>00144 <span class="comment">    ierr = VecPermute(gdata-&gt;VH1,isvert,PETSC_FALSE);CHKERRQ(ierr);</span>
<a name="l00145"></a>00145 <span class="comment">  }</span>
<a name="l00146"></a>00146 <span class="comment">  if (gdata-&gt;VH2!=PETSC_NULL) {</span>
<a name="l00147"></a>00147 <span class="comment">    ierr = VecPermute(gdata-&gt;VH2,isvert,PETSC_FALSE);CHKERRQ(ierr);</span>
<a name="l00148"></a>00148 <span class="comment">  }</span>
<a name="l00149"></a>00149 <span class="comment">#endif</span>
<a name="l00150"></a>00150 <span class="comment">*/</span>
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   PetscReal *ta_data;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_data);CHKERRQ(ierr);
<a name="l00155"></a>00155   ierr = AOApplicationToPetscPermuteReal(t_ao,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_data);CHKERRQ(ierr);
<a name="l00156"></a>00156   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_data);CHKERRQ(ierr);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;VH1!=PETSC_NULL) {
<a name="l00160"></a>00160     ierr = VecGetArray(gdata-&gt;VH1,&amp;ta_data);CHKERRQ(ierr);
<a name="l00161"></a>00161     ierr = AOApplicationToPetscPermuteReal(t_ao,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_data);CHKERRQ(ierr);
<a name="l00162"></a>00162     ierr = VecRestoreArray(gdata-&gt;VH1,&amp;ta_data);CHKERRQ(ierr);
<a name="l00163"></a>00163   }
<a name="l00164"></a>00164   <span class="keywordflow">if</span> (gdata-&gt;VH2!=PETSC_NULL) {
<a name="l00165"></a>00165     ierr = VecGetArray(gdata-&gt;VH2,&amp;ta_data);CHKERRQ(ierr);
<a name="l00166"></a>00166     ierr = AOApplicationToPetscPermuteReal(t_ao,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_data);CHKERRQ(ierr);
<a name="l00167"></a>00167     ierr = VecRestoreArray(gdata-&gt;VH2,&amp;ta_data);CHKERRQ(ierr);
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="comment">/* renumber vertcoupl such that all are coupled to the vertex with min. id */</span>
<a name="l00171"></a>00171   <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00172"></a>00172     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00173"></a>00173       <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[i]&lt;0) <span class="keywordflow">continue</span>;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175       <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[i]&gt;i) {
<a name="l00176"></a>00176         <span class="keywordtype">int</span> k;
<a name="l00177"></a>00177         k=gdata-&gt;vertcoupl[i];
<a name="l00178"></a>00178         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=i+1;j&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;j++) {
<a name="l00179"></a>00179           <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[j]&lt;0) <span class="keywordflow">continue</span>;
<a name="l00180"></a>00180           <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[j]==k) {
<a name="l00181"></a>00181             gdata-&gt;vertcoupl[j]=i;
<a name="l00182"></a>00182           }
<a name="l00183"></a>00183           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[gdata-&gt;vertcoupl[j]]==i) {
<a name="l00184"></a>00184             gdata-&gt;vertcoupl[j]=i;
<a name="l00185"></a>00185           }
<a name="l00186"></a>00186           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[gdata-&gt;vertcoupl[j]]==k) {
<a name="l00187"></a>00187             gdata-&gt;vertcoupl[j]=i;
<a name="l00188"></a>00188           }
<a name="l00189"></a>00189         }
<a name="l00190"></a>00190       }
<a name="l00191"></a>00191       assert(gdata-&gt;vertcoupl[i]&lt;i || gdata-&gt;vertcoupl[gdata-&gt;vertcoupl[i]]==i);
<a name="l00192"></a>00192       <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[i]&lt;i) {
<a name="l00193"></a>00193         assert(gdata-&gt;vertcoupl[gdata-&gt;vertcoupl[gdata-&gt;vertcoupl[i]]]==gdata-&gt;vertcoupl[i]);
<a name="l00194"></a>00194       }
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>
<a name="l00199"></a>00199   ierr = AOPetscToApplicationPermuteInt(t_ao,1,gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>);CHKERRQ(ierr);
<a name="l00200"></a>00200   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,size,0);
<a name="l00201"></a>00201   ierr = AODestroy(t_ao);CHKERRQ(ierr);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="comment">/* permute element data */</span>
<a name="l00205"></a>00205   ierr = AOCreateBasicIS(isele,PETSC_NULL,&amp;t_ao);CHKERRQ(ierr);
<a name="l00206"></a>00206   ierr = AOApplicationToPetscPermuteInt(t_ao,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>);CHKERRQ(ierr);
<a name="l00207"></a>00207   ierr = AOApplicationToPetscPermuteInt(t_ao,1,gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>);CHKERRQ(ierr);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   ierr = AOPetscToApplicationPermuteInt(t_ao,1,gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>);CHKERRQ(ierr);
<a name="l00210"></a>00210   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,0);
<a name="l00211"></a>00211   ierr = AODestroy(t_ao);CHKERRQ(ierr);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">/* newproc, l2g should be in ascending order now */</span>
<a name="l00215"></a>00215   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++)
<a name="l00216"></a>00216   {
<a name="l00217"></a>00217     assert(gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]&gt;=gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i-1]);
<a name="l00218"></a>00218     assert(gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]==i);
<a name="l00219"></a>00219   }
<a name="l00220"></a>00220   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++)
<a name="l00221"></a>00221   {
<a name="l00222"></a>00222     assert(gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]&gt;=gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i-1]);
<a name="l00223"></a>00223     assert(gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]==i);
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="comment">/* Reorder (Renumber) nodes to reduce matrix bandwidth */</span>
<a name="l00231"></a><a class="code" href="reorder_8c.html#aaa65da5c15989b05f5beaa0caec46fa6">00231</a> <span class="keywordtype">int</span> <a class="code" href="reorder_8c.html#aaa65da5c15989b05f5beaa0caec46fa6">OptimizeBandwidth</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>     dooptimizebw;
<a name="l00234"></a>00234   PetscTruth   flg;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="keywordtype">int</span> rank,size;
<a name="l00239"></a>00239   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00240"></a>00240   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="keywordflow">if</span> (rank) {
<a name="l00243"></a>00243     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00244"></a>00244   }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-optimizebw&quot;</span>,&amp;dooptimizebw,&amp;flg);CHKERRQ(ierr);
<a name="l00247"></a>00247   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00248"></a>00248     dooptimizebw=1;
<a name="l00249"></a>00249     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00250"></a>00250       <span class="stringliteral">&quot;Option -optimizebw not found, using default value %i (enabled)!\n&quot;</span>,
<a name="l00251"></a>00251       dooptimizebw
<a name="l00252"></a>00252     );
<a name="l00253"></a>00253   }
<a name="l00254"></a>00254   <span class="keywordflow">if</span> (dooptimizebw&lt;0) {
<a name="l00255"></a>00255     SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;-optimizebw invalid! Exiting!\n&quot;</span>);
<a name="l00256"></a>00256   }
<a name="l00257"></a>00257   <span class="keywordflow">if</span> (dooptimizebw==0) {
<a name="l00258"></a>00258     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Matrix bandwidth optimization not performed.\n&quot;</span>);
<a name="l00259"></a>00259     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00260"></a>00260   }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   Mat Atest;
<a name="l00263"></a>00263   IS isvert,isrow;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <a class="code" href="matcreateseqadj_8c.html#a75401ceb9e40834d9b15671f96a9c03a">matcreateseqadj</a>(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;Atest);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   ierr = MatGetOrdering(Atest,MATORDERING_RCM,&amp;isrow,&amp;isvert);CHKERRQ(ierr);
<a name="l00268"></a>00268   ierr = ISDestroy(isrow);CHKERRQ(ierr);
<a name="l00269"></a>00269   ierr = MatDestroy(Atest);CHKERRQ(ierr);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keywordtype">int</span> iss;
<a name="l00272"></a>00272   ierr = ISGetSize(isvert,&amp;iss);CHKERRQ(ierr);
<a name="l00273"></a>00273   assert(iss==gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="preprocessor">#if PETSC_VERSION &gt;= 300</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> *pind;
<a name="l00277"></a>00277 <span class="preprocessor">#else</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>  <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> *pind;
<a name="l00279"></a>00279 <span class="preprocessor">#endif</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>  ierr = ISGetIndices(isvert,&amp;pind);CHKERRQ(ierr);
<a name="l00281"></a>00281   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00282"></a>00282     gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]=pind[i];
<a name="l00283"></a>00283   }
<a name="l00284"></a>00284   ierr = ISRestoreIndices(isvert,&amp;pind);CHKERRQ(ierr);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00287"></a>00287     gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]=i;
<a name="l00288"></a>00288   }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">/* generate trivial mesh partitioning (just split according to vertex id) */</span>
<a name="l00291"></a>00291   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00292"></a>00292     gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,size,i);
<a name="l00293"></a>00293   }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="comment">/* partition elements based on vertex data */</span>
<a name="l00296"></a>00296   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00297"></a>00297     <span class="comment">/* trivial partitioning */</span>
<a name="l00298"></a>00298     gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,size,i);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300     <span class="comment">/* partition elements based on vertex data */</span>
<a name="l00301"></a>00301 <span class="comment">/* disabled to make sure that nothing gets renumbered</span>
<a name="l00302"></a>00302 <span class="comment">    gdata-&gt;elenewproc[i]=gdata-&gt;vertnewproc[gdata-&gt;elevert[NV*i+0]];</span>
<a name="l00303"></a>00303 <span class="comment">*/</span>
<a name="l00304"></a>00304   }
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">/* Create a global reordering (mapping) of the elements</span>
<a name="l00307"></a>00307 <span class="comment">     by permuting the trivial mapping</span>
<a name="l00308"></a>00308 <span class="comment">  */</span>
<a name="l00309"></a>00309   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,0);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   IS isele;
<a name="l00312"></a>00312   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,&amp;isele);CHKERRQ(ierr);
<a name="l00313"></a>00313   ierr = ISSetPermutation(isele);CHKERRQ(ierr);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   ierr = <a class="code" href="init_8h.html#a6924d6317e2e503ad009880947d9f905">CheckPartition</a>(gdata,size);CHKERRQ(ierr);
<a name="l00316"></a>00316   ierr = <a class="code" href="init_8h.html#a325dee9c88a63835d07e633aac72bc7e">PermuteData</a>(gdata,isvert,isele);CHKERRQ(ierr);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   ierr = ISDestroy(isvert);CHKERRQ(ierr);
<a name="l00319"></a>00319   ierr = ISDestroy(isele);CHKERRQ(ierr);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a><a class="code" href="reorder_8c.html#a6f34cee4815f64fdb70ac23efe121a18">00326</a> <span class="keywordtype">int</span> <a class="code" href="reorder_8c.html#a6f34cee4815f64fdb70ac23efe121a18">TrivialPartitioning</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="keywordtype">int</span> rank,size;
<a name="l00331"></a>00331   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00332"></a>00332   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keywordflow">if</span> (rank) {
<a name="l00335"></a>00335     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00336"></a>00336   }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="preprocessor">#if 1</span>
<a name="l00339"></a>00339 <span class="preprocessor"></span>  <span class="comment">/* create trivial local-&gt;global mappings */</span>
<a name="l00340"></a>00340   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00341"></a>00341     gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]=i;
<a name="l00342"></a>00342   }
<a name="l00343"></a>00343   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00344"></a>00344     gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]=i;
<a name="l00345"></a>00345   }
<a name="l00346"></a>00346 <span class="preprocessor">#else</span>
<a name="l00347"></a>00347 <span class="preprocessor"></span>  <span class="comment">/* DEBUG: revert numbering of nodes (for testing purposes)</span>
<a name="l00348"></a>00348 <span class="comment">     (activate PermuteDate below!)</span>
<a name="l00349"></a>00349 <span class="comment">   */</span>
<a name="l00350"></a>00350   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00351"></a>00351     gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>-1-i;
<a name="l00352"></a>00352   }
<a name="l00353"></a>00353   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>; i++) {
<a name="l00354"></a>00354     gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>[i]=gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>-1-i;
<a name="l00355"></a>00355   }
<a name="l00356"></a>00356 <span class="preprocessor">#endif</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span>
<a name="l00358"></a>00358   <span class="comment">/* generate trivial mesh partitioning (just split according to vertex id) */</span>
<a name="l00359"></a>00359   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00360"></a>00360     gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,size,i);
<a name="l00361"></a>00361   }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00364"></a>00364     <span class="comment">/* trivial partitioning */</span>
<a name="l00365"></a>00365     gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,size,i);
<a name="l00366"></a>00366 
<a name="l00367"></a>00367     <span class="comment">/* partition elements based on vertex data */</span>
<a name="l00368"></a>00368 <span class="comment">/* disabled to make sure that nothing gets renumbered</span>
<a name="l00369"></a>00369 <span class="comment">    gdata-&gt;elenewproc[i]=gdata-&gt;vertnewproc[gdata-&gt;elevert[NV*i+0]];</span>
<a name="l00370"></a>00370 <span class="comment">*/</span>
<a name="l00371"></a>00371   }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">/* Create a global reordering (mapping) of the elements</span>
<a name="l00374"></a>00374 <span class="comment">     by permuting the trivial mapping</span>
<a name="l00375"></a>00375 <span class="comment">  */</span>
<a name="l00376"></a>00376   <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,0);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="comment">/* Permute data according to new numbering */</span>
<a name="l00379"></a>00379   IS isvert,isele;
<a name="l00380"></a>00380   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>,&amp;isvert);CHKERRQ(ierr);
<a name="l00381"></a>00381   ierr = ISSetPermutation(isvert);CHKERRQ(ierr);
<a name="l00382"></a>00382   ierr = ISCreateGeneral(PETSC_COMM_SELF,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,&amp;isele);CHKERRQ(ierr);
<a name="l00383"></a>00383   ierr = ISSetPermutation(isele);CHKERRQ(ierr);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   ierr = <a class="code" href="init_8h.html#a6924d6317e2e503ad009880947d9f905">CheckPartition</a>(gdata,size);CHKERRQ(ierr);
<a name="l00386"></a>00386 <span class="preprocessor">#if 0</span>
<a name="l00387"></a>00387 <span class="preprocessor"></span>  <span class="comment">/* Apparently we don&#39;t have to do this for TrivialPartitioning (no renumbering) */</span>
<a name="l00388"></a>00388   ierr = <a class="code" href="init_8h.html#a325dee9c88a63835d07e633aac72bc7e">PermuteData</a>(gdata,isvert,isele);CHKERRQ(ierr);
<a name="l00389"></a>00389 <span class="preprocessor">#endif</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span>
<a name="l00391"></a>00391   ierr = ISDestroy(isvert);CHKERRQ(ierr);
<a name="l00392"></a>00392   ierr = ISDestroy(isele);CHKERRQ(ierr);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00395"></a>00395 }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <span class="comment">/* Reorder/renumber nodes and elements */</span>
<a name="l00399"></a><a class="code" href="reorder_8c.html#a37fbeb81912fa6f3e4bcc7e3dd71bc62">00399</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#a37fbeb81912fa6f3e4bcc7e3dd71bc62">Reorder</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00400"></a>00400 {
<a name="l00401"></a>00401   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="keywordtype">int</span> rank,size;
<a name="l00404"></a>00404   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00405"></a>00405   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="keywordflow">if</span> (rank) {
<a name="l00408"></a>00408     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00409"></a>00409   }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>);CHKERRQ(ierr);
<a name="l00412"></a>00412   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>);CHKERRQ(ierr);
<a name="l00413"></a>00413   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>);CHKERRQ(ierr);
<a name="l00414"></a>00414   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>);CHKERRQ(ierr);
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   ierr = <a class="code" href="reorder_8c.html#a6f34cee4815f64fdb70ac23efe121a18">TrivialPartitioning</a>(gdata);CHKERRQ(ierr);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">/* Optimize stiffness matrix bandwidth */</span>
<a name="l00419"></a>00419   ierr = <a class="code" href="reorder_8c.html#aaa65da5c15989b05f5beaa0caec46fa6">OptimizeBandwidth</a>(gdata);CHKERRQ(ierr);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">/* mesh partitioning */</span>
<a name="l00422"></a>00422   ierr = <a class="code" href="init_8h.html#a6458904885e6dd97ed495c8ad5f11ca0">DataPartitionElementsSer</a>(gdata);CHKERRQ(ierr);
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00425"></a>00425 }
<a name="l00426"></a>00426 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

